package com.genericparallel;

import java.util.HashMap;
import java.util.Map;

import org.apache.xmlbeans.XmlObject;

public class Verify {

	private static Map<String,Long> cache = new HashMap<String,Long>();

	public static void verify(String accountNumber,String tss) throws Exception {
		long ts = Long.parseLong(tss);

		synchronized(cache) {
			for( Map.Entry<String,Long> val: cache.entrySet() ) {
				String key = val.getKey();
				Long last = val.getValue();

				if( key.equals(accountNumber) ) {
					// same key, the new TS must be bigger than or same as the current one
					if( ts < last ) {
						// increment error count
						Long cnt = cache.get(accountNumber+".errorCount");
						if( cnt == null ) cnt = 0l;
						cache.put(accountNumber+".errorCount",cnt+1);

						throw new RuntimeException("account "+accountNumber+" already seen "+last+" but now got "+ts);
					}
				} else {
					// different accounts, it is OK that current TS is smaller; still log it for information
					if( ts < last ) {
						// increment error count
						Long cnt = cache.get(accountNumber+".ooo");
						if( cnt == null ) cnt = 0l;
						cache.put(accountNumber+".ooo",cnt+1);

						System.out.println("UOO NOTE: account "+key+" already seen "+last+" but now account "+accountNumber+" got "+ts);
					}
				}
			}

			cache.put(accountNumber,ts);

			Long tot = cache.get(accountNumber+".total");
			if( tot == null ) tot = 0l;
			cache.put(accountNumber+".total",tot+1);
		}
	}

	public static XmlObject getStats(String accountNumber) throws Exception {
		Long err = null;
		Long tot = null;
		Long ooo = null;

		synchronized(cache) {
			err = cache.get(accountNumber+".errorCount");
			tot = cache.get(accountNumber+".total");
			ooo = cache.get(accountNumber+".ooo");
		}

		if( err == null ) err = 0l;
		if( tot == null ) tot = 0l;
		if( ooo == null ) ooo = 0l;

		StringBuilder sb = new StringBuilder();
		sb.append("<stats>");
		sb.append("<total>").append(tot).append("</total>");
		sb.append("<errors>").append(err).append("</errors>");
		sb.append("<cross-account-ooo>").append(ooo).append("</cross-account-ooo>");
		sb.append("</stats>");
			
		return XmlObject.Factory.parse(sb.toString() );
	}
}